//////////////////////////////////////////////////
//////////////////////////////////////////////////
// This source code is Copyright (2011) of      //
//  Jeppe R. Andersen and Jennifer M. Smillie   //
// and is distributed under the                 //
// Gnu Public License version 2                 //
// http://www.gnu.org/licenses/gpl-2.0.html     //
// You are allowed to distribute and alter the  //
// source under the conditions of the GPLv2     //
// as long as this copyright notice             //
// is unaltered and distributed with the source //
// Any use should comply with the               //
//             MCNET GUIDELINES                 //
//    for Event Generator Authors and Users     //
// as distributed with this source code         //
//////////////////////////////////////////////////
//////////////////////////////////////////////////
// Here we have routines which only define the momentum config we need, 
// and not the other 23!
#include "Jets.h"
#include "MomentumDefJet.h"

  // p1 = b(+) a(-) --> + -,   p2 = b(+) a(-) --> - +
  // p3 = a(-) b(+) --> - +,   p4 = a(-) b(+) --> + -

int MDtemp2[4][4]={{0,1,2,3}, //1
		   {0,1,3,2}, //2
		   {1,0,3,2}, //3
		   {1,0,2,3}  //4
};

  // p1 = b(+) a(-) --> + 0 -,   p2 = a(-) b(+) --> - 0 +
  // p3 = b(+) a(-) --> 0 + -,   p4 = b(+) a(-) --> + - 0
  // p5 = b(+) a(-) --> - 0 +,   p6 = b(+) a(-) --> 0 - +
  // p7 = b(+) a(-) --> - + 0,   p8 = a(-) b(+) --> 0 - +
  // p9 = a(-) b(+) --> - + 0,   p10= a(-) b(+) --> + 0 -
  // p11= a(-) b(+) --> 0 + -,   p12= a(-) b(+) --> + - 0

int MDtemp3[12][5]={{0,1,2,3,4}, //1
		   {1,0,4,3,2}, //2
		   {0,1,3,2,4}, //3
		   {0,1,2,4,3}, //4
		   {0,1,4,3,2}, //5
		   {0,1,3,4,2}, //6
		   {0,1,4,2,3}, //7
		   {1,0,3,4,2}, //8
		   {1,0,4,2,3}, //9
		   {1,0,2,3,4}, //10
		   {1,0,3,2,4}, //11
		   {1,0,2,4,3}  //12
};

  // p1  = b(+) a(-) --> ++ + - --,   p2  = b(+) a(-) --> ++ + -- -
  // p3  = b(+) a(-) --> ++ - + --,   p4  = b(+) a(-) --> ++ - -- +
  // p5  = b(+) a(-) --> ++ -- + -,   p6  = b(+) a(-) --> ++ -- - +
  // p7  = b(+) a(-) --> + ++ - --,   p8  = b(+) a(-) --> + ++ -- -
  // p9  = b(+) a(-) --> + - ++ --,   p10 = b(+) a(-) --> + - -- ++
  // p11 = b(+) a(-) --> + -- ++ -,   p12 = b(+) a(-) --> + -- - ++
  // p13 = b(+) a(-) --> -- - + ++,   p14 = b(+) a(-) --> -- - ++ +
  // p15 = b(+) a(-) --> -- + - ++,   p16 = b(+) a(-) --> -- + ++ -
  // p17 = b(+) a(-) --> -- ++ - +,   p18 = b(+) a(-) --> -- ++ + -
  // p19 = b(+) a(-) --> - -- + ++,   p20 = b(+) a(-) --> - -- ++ +
  // p21 = b(+) a(-) --> - + -- ++,   p22 = b(+) a(-) --> - + ++ --
  // p23 = b(+) a(-) --> - ++ -- +,   p24 = b(+) a(-) --> - ++ + --

  // p25 = a(-) b(+) --> -- - + ++,   p26 = a(-) b(+) --> -- - ++ +
  // p27 = a(-) b(+) --> -- + - ++,   p28 = a(-) b(+) --> -- + ++ -
  // p29 = a(-) b(+) --> -- ++ - +,   p30 = a(-) b(+) --> -- ++ + -
  // p31 = a(-) b(+) --> - -- + ++,   p32 = a(-) b(+) --> - -- ++ +
  // p33 = a(-) b(+) --> - + -- ++,   p34 = a(-) b(+) --> - + ++ --
  // p35 = a(-) b(+) --> - ++ -- +,   p36 = a(-) b(+) --> - ++ + --
  // p37 = a(-) b(+) --> ++ + - --,   p38 = a(-) b(+) --> ++ + -- -
  // p39 = a(-) b(+) --> ++ - + --,   p40 = a(-) b(+) --> ++ - -- +
  // p41 = a(-) b(+) --> ++ -- + -,   p42 = a(-) b(+) --> ++ -- - +
  // p43 = a(-) b(+) --> + ++ - --,   p44 = a(-) b(+) --> + ++ -- -
  // p45 = a(-) b(+) --> + - ++ --,   p46 = a(-) b(+) --> + - -- ++
  // p47 = a(-) b(+) --> + -- ++ -,   p48 = a(-) b(+) --> + -- - ++

int MDtemp[48][6]={{0,1,2,3,4,5}, //1
		 {0,1,2,3,5,4}, //2
		 {0,1,2,4,3,5}, //3
		 {0,1,2,4,5,3}, //4
		 {0,1,2,5,3,4}, //5
		 {0,1,2,5,4,3}, //6
		 {0,1,3,2,4,5}, //7
		 {0,1,3,2,5,4}, //8
		 {0,1,3,4,2,5}, //9
		 {0,1,3,4,5,2}, //10
		 {0,1,3,5,2,4}, //11
		 {0,1,3,5,4,2}, //12
		 {0,1,5,4,3,2}, //13
		 {0,1,5,4,2,3}, //14
		 {0,1,5,3,4,2}, //15
		 {0,1,5,3,2,4}, //16
		 {0,1,5,2,4,3}, //17
		 {0,1,5,2,3,4}, //18
		 {0,1,4,5,3,2}, //19
		 {0,1,4,5,2,3}, //20
		 {0,1,4,3,5,2}, //21
		 {0,1,4,3,2,5}, //22
		 {0,1,4,2,5,3}, //23
		 {0,1,4,2,3,5}, //24
                 {1,0,5,4,3,2}, //25
		 {1,0,5,4,2,3}, //26
		 {1,0,5,3,4,2}, //27
		 {1,0,5,3,2,4}, //28
		 {1,0,5,2,4,3}, //29
		 {1,0,5,2,3,4}, //30
		 {1,0,4,5,3,2}, //31
		 {1,0,4,5,2,3}, //32
		 {1,0,4,3,5,2}, //33
		 {1,0,4,3,2,5}, //34
		 {1,0,4,2,5,3}, //35
		 {1,0,4,2,3,5}, //36
		 {1,0,2,3,4,5}, //37
		 {1,0,2,3,5,4}, //38
		 {1,0,2,4,3,5}, //39
		 {1,0,2,4,5,3}, //40
		 {1,0,2,5,3,4}, //41
		 {1,0,2,5,4,3}, //42
		 {1,0,3,2,4,5}, //43
		 {1,0,3,2,5,4}, //44
		 {1,0,3,4,2,5}, //45
		 {1,0,3,4,5,2}, //46
		 {1,0,3,5,2,4}, //47
		 {1,0,3,5,4,2}  //48
};

double PickAndEvalProcAndMom2J(std::vector<sPMchoice> NonFKLProcesses, double p[4][4])
{
  static CLHEP::Ranlux64Engine ran;
  double pshuff[4][4];
  int ProcessLength=NonFKLProcesses.size();
  int ir1=int(ProcessLength*ran.flat());
  struct sPMchoice PMchoice=NonFKLProcesses[ir1];
  int MomChoiceLength=PMchoice.MomShuffleVector.size();
  int ir2=int(MomChoiceLength*ran.flat());
  int momshuffle=PMchoice.MomShuffleVector[ir2];

  for (int ii=0;ii < 4; ii++) {
    pshuff[ii][0]=p[MDtemp2[momshuffle][ii]][0];
    pshuff[ii][1]=p[MDtemp2[momshuffle][ii]][1];
    pshuff[ii][2]=p[MDtemp2[momshuffle][ii]][2];
    pshuff[ii][3]=p[MDtemp2[momshuffle][ii]][3];
  }

  double ME2;
  PMchoice.MGfunc(&pshuff[0][0],&ME2);
  //  std::cout<<ME2<<"  "<<MomChoiceLength<<"  "<<ProcessLength<<"  "<<PMchoice.idpartmult<<"  ";
  return ME2*double(MomChoiceLength*ProcessLength*PMchoice.idpartmult);
}

//1
double PickProcAndEval2J(std::vector<sPMchoice> NonFKLProcesses, double p[4][4])
{
  static CLHEP::Ranlux64Engine ran;
  double pshuff[4][4];
  int ir1;
  int ProcessLength=NonFKLProcesses.size();
  if (ProcessLength>1)
    ir1=int(ProcessLength*ran.flat());
  else
    ir1=0;
  struct sPMchoice PMchoice=NonFKLProcesses[ir1];
  int momshuffle=PMchoice.MomShuffleVector[0];

  for (int ii=0;ii < 4; ii++) {
    pshuff[ii][0]=p[MDtemp2[momshuffle][ii]][0];
    pshuff[ii][1]=p[MDtemp2[momshuffle][ii]][1];
    pshuff[ii][2]=p[MDtemp2[momshuffle][ii]][2];
    pshuff[ii][3]=p[MDtemp2[momshuffle][ii]][3];
  }

  double ME2;
  PMchoice.MGfunc(&pshuff[0][0],&ME2);
  return ME2*double(ProcessLength*PMchoice.idpartmult);
}

//2
double PickMomAndEval2J(std::vector<sPMchoice> NonFKLProcesses, double p[4][4])
{
  static CLHEP::Ranlux64Engine ran;
  double pshuff[4][4];
  struct sPMchoice PMchoice=NonFKLProcesses[0];
  int MomChoiceLength=PMchoice.MomShuffleVector.size();
  int ir2=int(MomChoiceLength*ran.flat());
  int momshuffle=PMchoice.MomShuffleVector[ir2];

  for (int ii=0;ii < 4; ii++) {
    pshuff[ii][0]=p[MDtemp2[momshuffle][ii]][0];
    pshuff[ii][1]=p[MDtemp2[momshuffle][ii]][1];
    pshuff[ii][2]=p[MDtemp2[momshuffle][ii]][2];
    pshuff[ii][3]=p[MDtemp2[momshuffle][ii]][3];
  }

  double ME2;
  PMchoice.MGfunc(&pshuff[0][0],&ME2);
  return ME2*double(MomChoiceLength*PMchoice.idpartmult);
}

//3
double NoPickButEval2J(std::vector<sPMchoice> NonFKLProcesses, double p[4][4])
{
  static CLHEP::Ranlux64Engine ran;
  double pshuff[4][4];
  struct sPMchoice PMchoice=NonFKLProcesses[0];
  int momshuffle=PMchoice.MomShuffleVector[0];

  for (int ii=0;ii < 4; ii++) {
    pshuff[ii][0]=p[MDtemp2[momshuffle][ii]][0];
    pshuff[ii][1]=p[MDtemp2[momshuffle][ii]][1];
    pshuff[ii][2]=p[MDtemp2[momshuffle][ii]][2];
    pshuff[ii][3]=p[MDtemp2[momshuffle][ii]][3];
  }

  double ME2;
  PMchoice.MGfunc(&pshuff[0][0],&ME2);
  return ME2*double(PMchoice.idpartmult);
}

double PickAndEvalProcAndMom3J(std::vector<sPMchoice> NonFKLProcesses, double p[5][4])
{
  static CLHEP::Ranlux64Engine ran;
  double pshuff[5][4];
  int ir1;
  int ProcessLength=NonFKLProcesses.size();
  if (ProcessLength>1)
    ir1=int(ProcessLength*ran.flat());
  else
    ir1=0;
  struct sPMchoice PMchoice=NonFKLProcesses[ir1];
  int MomChoiceLength=PMchoice.MomShuffleVector.size();
  int ir2=int(MomChoiceLength*ran.flat());
  int momshuffle=PMchoice.MomShuffleVector[ir2];

  for (int ii=0;ii < 5; ii++) {
    pshuff[ii][0]=p[MDtemp3[momshuffle][ii]][0];
    pshuff[ii][1]=p[MDtemp3[momshuffle][ii]][1];
    pshuff[ii][2]=p[MDtemp3[momshuffle][ii]][2];
    pshuff[ii][3]=p[MDtemp3[momshuffle][ii]][3];
  }

  double ME2;
  PMchoice.MGfunc(&pshuff[0][0],&ME2);
  return ME2*double(MomChoiceLength*ProcessLength*PMchoice.idpartmult);
}

//2
double PickMomAndEval3J(std::vector<sPMchoice> NonFKLProcesses, double p[5][4])
{
  static CLHEP::Ranlux64Engine ran;
  double pshuff[5][4];
  struct sPMchoice PMchoice=NonFKLProcesses[0];
  int MomChoiceLength=PMchoice.MomShuffleVector.size();
  int ir2=int(MomChoiceLength*ran.flat());
  int momshuffle=PMchoice.MomShuffleVector[ir2];

  for (int ii=0;ii < 5; ii++) {
    pshuff[ii][0]=p[MDtemp3[momshuffle][ii]][0];
    pshuff[ii][1]=p[MDtemp3[momshuffle][ii]][1];
    pshuff[ii][2]=p[MDtemp3[momshuffle][ii]][2];
    pshuff[ii][3]=p[MDtemp3[momshuffle][ii]][3];
  }

  double ME2;
  PMchoice.MGfunc(&pshuff[0][0],&ME2);
  return ME2*double(MomChoiceLength*PMchoice.idpartmult);
}

double PickAndEvalProcAndMom4J(std::vector<sPMchoice> NonFKLProcesses, double p[6][4])
{
  static CLHEP::Ranlux64Engine ran;
  double pshuff[6][4];
  int ProcessLength=NonFKLProcesses.size();
  int ir1=int(ProcessLength*ran.flat());
  struct sPMchoice PMchoice=NonFKLProcesses[ir1];
  int MomChoiceLength=PMchoice.MomShuffleVector.size();
  int ir2=int(MomChoiceLength*ran.flat());
  int momshuffle=PMchoice.MomShuffleVector[ir2];

  for (int ii=0;ii < 6; ii++) {
    pshuff[ii][0]=p[MDtemp[momshuffle][ii]][0];
    pshuff[ii][1]=p[MDtemp[momshuffle][ii]][1];
    pshuff[ii][2]=p[MDtemp[momshuffle][ii]][2];
    pshuff[ii][3]=p[MDtemp[momshuffle][ii]][3];
  }

  double ME2;
  PMchoice.MGfunc(&pshuff[0][0],&ME2);
  //  std::cout<<"MomDef: "<<ME2<<"  "<<MomChoiceLength<<"  "<<ProcessLength<<"  "<<PMchoice.idpartmult<<"  "<<momshuffle<<"\n";
  //  std::cout<<momshuffle<<"  "<<pshuff[0][3]<<"  "<<pshuff[1][3]<<"  "<<pshuff[2][3]<<"  "<<pshuff[3][3]<<"  "<<pshuff[4][3]<<"  "<<pshuff[5][3]<<"  "<<pshuff[6][3]<<"  "<<pshuff[7][3]<<"\n";
  return ME2*double(MomChoiceLength*ProcessLength*PMchoice.idpartmult);
}

