C***********************************************************************
C $Id: armeps.f,v 3.34 2009/04/20 10:08:05 nils Exp $

      SUBROUTINE ARMEPS

C...ARiadne function Matrix Element Parton shower interface version 3

C...Add dipole cascade to fixed order matrix elements

      INCLUDE 'arimpl.f'
      INCLUDE 'arpart.f'
      INCLUDE 'ardips.f'
      INCLUDE 'arstrs.f'
      INCLUDE 'ardat1.f'
      INCLUDE 'arhide.f'
      INCLUDE 'arint3.f'
      INCLUDE 'aronia.f'
      INCLUDE 'pyjets.f'
      INCLUDE 'pydat1.f'
      INCLUDE 'pypars.f'
      INCLUDE 'arstrf.f'
      INCLUDE 'leptou.f'

      DIMENSION PT(0:6),PTMINI(0:5),PTMAXI(0:5)
      DIMENSION I1(5),I2(5),I3(5),PT2(5),XPYST(-25:25)

      INCLUDE 'ardble.f'

      INXTP(I)=IP3(IDO(I))
      IPRVP(I)=IP1(IDI(I))

C      QREDO = .FALSE.
C 1000 CONTINUE

      MHAR(163)=1
      PHAR(163)=1.0

C...If an error occured discard event.
      IF(MSTA(13).GT.0) GOTO 999

C...First scan and save the event record
      XDUM=0.0
      NHQ=0
C      CALL ARSCAN(NSTART,NEND,0,IDUM)
      QDUMP=.FALSE.
      PT2LST=DBLE(PARA(40))

C...Save the initial flavours in KFSAVE
      KFSAVE(1) = MSTI(13)
      KFSAVE(2) = MSTI(14)

C...Check that initial jets are actually above specified cuts
      IF ( ARMECU(1,IPART).LT.0.0D0 ) GOTO 999

C...Calculate total momentum of strings for debugging
      IF (MSTA(9).GT.0) CALL ARCHEM(1)

      CALL ARPUTR(10)

C...Get the number of steps we have to go back
      NEMIT=MHAR(161)-MHAR(162)
      IF ( NEMIT.GT.5 ) THEN
        CALL ARERRM('ARMEPS',39,0)
        GOTO 999
      ENDIF

      PT(0)=0.0
      PTMAXI(0)=0.0
      PTMINI(0)=0.0
      IF ( MHAR(160).EQ.1 ) PT(0)=DBLE(PHAR(161))

 400  IF ( NEMIT.GT.0 ) THEN
        CALL ARRECS(I1,I2,I3,PT2,NEMIT)
        IF ( I1(1).LE.0.OR.I2(1).LE.0.OR.I3(1).LE.0 ) THEN
C          GOTO 999
          NEMIT = NEMIT - 1
          GOTO 400
        ENDIF
C        IF ( I1(1).LE.0.OR.I2(1).LE.0.OR.I3(1).LE.0 ) THEN
C          IF (MHAR(167).EQ.0) CALL ARERRM('ARMEPS',39,0)
C          WRITE(*,*) 'ARMEPS: Warning no possible reconstruction'
C          GOTO 999
C        ENDIF
      ENDIF

C...Save the initial flavours in KFSAVE
      KFSAVE(1) = MSTI(13)
      KFSAVE(2) = MSTI(14)

C...Reconstruct the most likely equivalent cascade
      DO 100 IEMIT=1,NEMIT

        PT(IEMIT)=SQRT(PT2(IEMIT))
        PTMAXI(IEMIT)=MAX(PT(IEMIT),PTMAXI(IEMIT-1))
        IF ( MHAR(160).EQ.1.AND.PT(IEMIT).LT.PT(0) ) GOTO 999

C...Weight with running alpha_s
        IF(MHAR(188).EQ.0)THEN
          STOT=ARMAS3(I1(IEMIT),I2(IEMIT),I3(IEMIT))
          ALPRAT=ARALPS(PT2(IEMIT),STOT)/DBLE(PHAR(160))
C        ALPRAT=PYALPS(PT2(IEMIT))/DBLE(PHAR(160))
C        ALPRAT=ARALPS(PT2(IEMIT),STOT)/
C     $       ARALPS(DBLE(PHAR(161))**2,DPTOT(5)**2)
          IF (MHAR(183).eq.0) THEN
            IF (ALPRAT.LT.PYR(0)) GOTO 999
          ELSE
            PHAR(163)=PHAR(163)*ALPRAT
          ENDIF
        ENDIF

        IF(MHAR(184).GE.2)THEN
          IF (MHAR(183).EQ.0) THEN
            IF(ARPROB(I1(IEMIT),I2(IEMIT),I3(IEMIT),PT(IEMIT)**2,.TRUE.)
     $           .LT.PYR(0)) GOTO 999
          ELSE
            PHAR(163)=PHAR(163)*ARPROB(I1(IEMIT),I2(IEMIT),
     $           I3(IEMIT),PT(IEMIT)**2,.TRUE.)
          ENDIF
        ENDIF

C DEBUG
C        WRITE(*,*) 'ARALPHAS ',ARALPS(PT2(IEMIT),STOT),
C     $       ' PYAlphas ', PYALPS(PT2(IEMIT))
C DEBUG
C...Now reconstruct the previous step and save it
        CALL ARUNDO(I1(IEMIT),I2(IEMIT),I3(IEMIT))
C        CALL ARPUTR(10-IEMIT)

 100  CONTINUE

      IF (NEMIT .LT. MHAR(161)-MHAR(162)) THEN
C        DUMMY = ARPRNT()
        SHAT = ARSHAT()
        ALPRAT=ARALPS(SHAT,SHAT)/DBLE(PHAR(160))
        IEMIT = MHAR(161)-MHAR(162)-NEMIT
        IF (MHAR(183).eq.0) THEN
          IF (ALPRAT**IEMIT.LT.PYR(0)) GOTO 999
        ELSE
          PHAR(163)=PHAR(163)*ALPRAT**IEMIT
        ENDIF
      ENDIF

C ... If asked to use ME-PS corrections on hadron initial state
      IF(MHAR(184).GE.2)THEN
        IF(MHAR(184).NE.3) THEN
          CALL ARLCCO(PPLUS, PMINUS, PX, PY, S)
          IF(S .LE. 1.69) THEN
            S = 1.69
          ENDIF
          X1 = PPLUS/(P(1,4)+P(1,3))
          X2 = PMINUS/(P(2,4)-P(2,3))
        ELSE
          X1 = X
          X2 = X
          S =  XQ2
        ENDIF

        QSEA1R = QQ(MAXPAR-4)
        QSEA2R = QQ(MAXPAR-3)

        IFLV1 = KFSAVE(1)
        IFLV2 = KFSAVE(2)

        CALL ARGETR(10)

        QSEA1 = QQ(MAXPAR-4)
        QSEA2 = QQ(MAXPAR-3)

C ... If beam 1 hadron
        XW=1.0D0
        IF(ABS(K(1,2)).GT.100) THEN
          CALL PYPDFU(K(1,2),X1,S,XPYST)
          IF(IFLV1.EQ.21)THEN
            XW = XPYST(IFLV1)
          ELSE
            IF(QSEA1R)THEN
              XW = MIN(XPYST(IFLV1), XPYST(-IFLV1))
            ELSE
              XW = XPYST(IFLV1)-XPYST(-IFLV1)
            ENDIF
          ENDIF
  
          CALL PYPDFU(K(1,2),ARX2DB(PARI(31)),DBLE(PHAR(161))**2,XPYST)
          IF(MSTI(13).EQ.21)THEN
            XW = XW/XPYST(MSTI(13))
          ELSE
            IF(QSEA1)THEN
              XW = XW/MIN(XPYST(MSTI(13)), XPYST(-MSTI(13)))
            ELSE
              XW = XW/(XPYST(MSTI(13))-XPYST(-MSTI(13)))
            ENDIF
          ENDIF
        ENDIF
        
C ... If beam 2 hadron
        IF(ABS(K(2,2)).GT.100) THEN
          CALL PYPDFU(K(2,2),X2,S,XPYST)
          IF(MHAR(184).EQ.3) THEN
            IF(MSTI(14).NE.IFLV2) THEN
              XW = XW*MIN(XPYST(IFLV2), XPYST(-IFLV2))
            ELSE
              XW = XW*XPYST(IFLV2)
            ENDIF
          ELSE
            IF(IFLV2.EQ.21)THEN
              XW = XW*XPYST(IFLV2)
            ELSE
              IF(QSEA2R)THEN
                XW = XW*MIN(XPYST(IFLV2), XPYST(-IFLV2))
              ELSE
                XW = XW*(XPYST(IFLV2)-XPYST(-IFLV2))
              ENDIF
            ENDIF
          ENDIF

          CALL PYPDFU(K(2,2),ARX2DB(PARI(32)),DBLE(PHAR(161))**2,XPYST)
          IF(MHAR(184).EQ.3) THEN
            XW = XW/XPYST(MSTI(14))
          ELSE
            IF(MSTI(14).EQ.21)THEN
              XW = XW/XPYST(MSTI(14))
            ELSE
              IF(QSEA2)THEN
                XW = XW/MIN(XPYST(MSTI(14)), XPYST(-MSTI(14)))
              ELSE
                XW = XW/(XPYST(MSTI(14))-XPYST(-MSTI(14)))
              ENDIF
            ENDIF
          ENDIF
        ENDIF

        IF (MHAR(183).eq.0) THEN
          IF (XW.LT.PYR(0)) GOTO 999
        ELSE
          PHAR(163)=PHAR(163)*XW
        ENDIF

      ENDIF        

      CALL ARGETR(10)

      PT(NEMIT+1)=DBLE(PARA(40))
      PTMAXI(NEMIT+1)=DBLE(PARA(40))
      PTMINI(NEMIT+1)=DBLE(PARA(40))
      DO 210 IEMIT=NEMIT,1,-1
        PTMINI(IEMIT)=MIN(PTMINI(IEMIT+1),PT(IEMIT))
 210  CONTINUE

      IF ( MHAR(165).LE.1 ) THEN
        DO 220 IEMIT=NEMIT,1,-1
          IF ( MHAR(165).EQ.1)
     $         PTMINI(IEMIT)=SQRT(PTMAXI(IEMIT)*PTMINI(IEMIT))
          PTMAXI(IEMIT)=PTMINI(IEMIT)
 220    CONTINUE
      ENDIF

C      DO 200 IEMIT=NEMIT,1,-1
C
CC...Make one trial emission
C        NP=IPART
C        CALL AREVO1(PTMINI(IEMIT+1),PTMAXI(IEMIT))
C        IF ( IPART.GT.NP ) RETURN
C
CC...Recall next saved partonic state
C        CALL ARGETR(11-IEMIT)
C
C 200  CONTINUE
      IF ( MHAR(188).GT.0 ) THEN
        WGTNLO = ARNLO(I1,I2,I3,PT2,NEMIT)
        IF(WGTNLO.EQ.0.0D0) GOTO 999
        PHAR(163)=PHAR(163)*WGTNLO
      ELSE
        IF ( ARSUVE(I1,I2,I3,PT2,NEMIT).LT.0.0D0 ) GOTO 999
        IF ( MSTA(28).NE.0 ) THEN
          DO 300 I=1,IPART
            IF ( .NOT.QQ(I) ) PT2GG(I)=PTMINI(1)**2
 300      CONTINUE
        ENDIF
        IO = MHAR(161)-MHAR(162)
        IF ( MHAR(162).GT.0 ) THEN
C...loops
          NP=IPART
          CALL AREVO1(PTMINI(1),0.0D0)
          IF ( IPART.GT.NP ) THEN
            IF ( ARMECU(NP+1,IPART).GT.0.0D0 ) then
              GOTO 999
            endif
          ENDIF
          IF ( MHAR(170).EQ.0) CALL ARCONT
        ELSE
C...No loops
          IF ( MHAR(170).EQ.0) CALL AREVOL(PTMINI(1),0.0D0)
          IF (.NOT.QDUMP) CALL ARDUMP
        ENDIF
      ENDIF

      MHAR(163)=0

      RETURN

 999  PHAR(163)=0.0
      IF (.NOT.QDUMP) CALL ARDUMP

      RETURN

C**** END OF ARMEPS ****************************************************
      END

C***********************************************************************
      SUBROUTINE ARMEEX

C...ARiadne function Matrix Element EXecute

C...Runs Ariadne with a different weighting to deal with sea/valence
C...quarks, which should return less large weights.

      INCLUDE 'arimpl.f'
      INCLUDE 'arhide.f'
      INCLUDE 'pyjets.f'
      INCLUDE 'pydat1.f'
      INCLUDE 'pypars.f'

      DOUBLE PRECISION XPYST(-25:25)

      MHAR(186)=0
      WEIGHT=1.0D0

      IF(MSTI(11).EQ.2212.AND.(MSTI(13).EQ.1.OR.MSTI(13).EQ.2).OR.
     $    MSTI(11).EQ.-2212.AND.(MSTI(13).EQ.-1.OR.MSTI(13).EQ.-2))THEN
C...Possible valence quarks
        CALL PYPDFU(MSTI(11),PARI(31),DBLE(PHAR(161))**2,XPYST)
        IF(PYR(0).GT.0.5D0)THEN
          WEIGHT=WEIGHT*2.0D0*(1.0D0-XPYST(-MSTI(13))/XPYST(MSTI(13)))
          MHAR(186)=1
        ELSE
          WEIGHT=WEIGHT*2.0D0*XPYST(-MSTI(13))/XPYST(MSTI(13))
          MHAR(186)=2
        ENDIF
      ELSE
C...Only sea quarks
        MHAR(186)=2
      ENDIF

      IF(MSTI(12).EQ.2212.AND.(MSTI(14).EQ.1.OR.MSTI(14).EQ.2).OR.
     $    MSTI(12).EQ.-2212.AND.(MSTI(14).EQ.-1.OR.MSTI(14).EQ.-2))THEN
C...Possible valence quarks
        CALL PYPDFU(MSTI(12),PARI(32),DBLE(PHAR(161))**2,XPYST)
        IF(PYR(0).GT.0.5D0)THEN
          WEIGHT=WEIGHT*2.0D0*(1.0D0-XPYST(-MSTI(14))/XPYST(MSTI(14)))
          MHAR(186)=10+MHAR(186)
        ELSE
          WEIGHT=WEIGHT*2.0D0*XPYST(-MSTI(14))/XPYST(MSTI(14))
          MHAR(186)=20+MHAR(186)
        ENDIF
      ELSE
C...Only sea quarks
        MHAR(186)=20+MHAR(186)
      ENDIF

      CALL AREXEC()
      IF(WEIGHT.GT.0.0D0) THEN
        PHAR(163)=PHAR(163)*WEIGHT
      ELSE
        PHAR(163)=0.0D0
      ENDIF

      END
C**** END OF ARMEPS ****************************************************
