C***********************************************************************
C     $Id: arprob.f,v 3.10 2008/01/22 14:52:43 nils Exp $

      DOUBLE PRECISION FUNCTION ARPROB(I1,I2,I3,PT2,QREC)

C...ARiadne function reconstructed PROBability

C...Returns the invariant p_t^2 of three partons

C...If QREC is true return only structure function quotient for sea quark
C...emission and the suppression factor for gluon emission.

      INCLUDE 'arimpl.f'
      INCLUDE 'arpart.f'
      INCLUDE 'ardips.f'
      INCLUDE 'ardat1.f'
      INCLUDE 'arhide.f'
      INCLUDE 'arint3.f'
      INCLUDE 'arstrf.f'
      INCLUDE 'pyjets.f'
      INCLUDE 'leptou.f'

      save prob,S12,S23,S123,SY1,SY2,SY3,Y12,Y23,XT2,X1,X3,X2,CF
      DIMENSION IPAR(MAXPAR), SBP(5), XPYST(-25:25)

      ARPROB=1.0D0

      S12 = ARMAS2(I1,I2)
      S23 = ARMAS2(I2,I3)
      S123 = ARMAS3(I1,I2,I3)

      SY1=BP(I1,5)/SQRT(S123)
      SY2=BP(I2,5)/SQRT(S123)
      SY3=BP(I3,5)/SQRT(S123)

      Y12 = S12/S123-(SY1+SY2)**2
      Y23 = S23/S123-(SY2+SY3)**2
      XT2 = Y12*Y23

      X1=1.0D0-(S23-BP(I1,5)**2)/S123
      X3=1.0D0-(S12-BP(I3,5)**2)/S123
      X2=2.0D0-X1-X3

      Y = 0.5D0*LOG(Y12/Y23)

      PROB=1.0D0
      IF ( MHAR(169).EQ.0 ) PROB=ARALPS(S123*XT2, S123)
      IF ( MHAR(169).EQ.2 ) RETURN

      IF ( IFL(I2).EQ.21 ) THEN
        IF(QEX(I1) .AND. QEX(I3) .AND. QQ(MAXPAR-2)
     $       .AND. IPART .LE. 3)THEN
C...Gluon emission from two extended sources
C...Gluon light cone cordinates
          PPG = BP(I2, 4) + BP(I2,3)
          PMG = BP(I2, 4) - BP(I2,3)
C...Boson light cone cordinates
          PPW = BP(MAXPAR-2, 4) + BP(MAXPAR-2,3)
          PMW = BP(MAXPAR-2, 4) - BP(MAXPAR-2,3)
C...Gluon kt
          KT2 = BP(I2,1)**2 + BP(I2,2)**2
C...Mandelstam variables
          SH = (PPG + PPW)*(PMG + PMW)
          TH = -PMG*PPW - KT2
          UH = -PPG*PMW - KT2
C...Probability according to matrix element
          PROB = 2.0D0/3.0D0*PROB*((SH+UH)**2+(SH+TH)**2)
     $         /(SH*UH*TH)
        ELSE
C...Probability for nonextended particles
          NXP1=2
          NXP3=2
          CF=2.0/3.0
          IF ( IFL(I1).EQ.21 ) THEN
            NXP1=3
            IF (MHAR(155).GT.0) NXP1=0
            CF=3.0/4.0
          ENDIF
          IF ( IFL(I3).EQ.21 ) THEN
            NXP3=3
            IF (MHAR(155).GT.0) NXP3=0
            CF=3.0/4.0
          ENDIF
          PROB=CF*PROB*(X1**NXP1+X3**NXP3)/PT2
        ENDIF
        
        IF ( QQ(MAXPAR-2) ) THEN
C...If Drell-Yan particle
C...If arprob is called during reconstruction of an event 
C...return 0 or 1/z
          ICOUNT=0
          IMAX=100
          IF(QREC)THEN
            A = 1.0D0
            B = 1.0D0
            DO 111 I = 1,IMAX
              IF(QEX(I1)) A = MIN((XPMU(I1)/SQRT(PT2))**XPA(I1)*
     $             (1.0D0/PYR(IDUM)-1.0D0)**DBLE(PARA(25)),1.0D0)
              IF(QEX(I3)) B = MIN((XPMU(I3)/SQRT(PT2))**XPA(I3)*
     $             (1.0D0/PYR(IDUM)-1.0D0)**DBLE(PARA(25)),1.0D0)
              XTMAX = A*B/(EXP(Y)*B+EXP(-Y)*A)
              IF(XTMAX**2.GT.PT2/S123)THEN
                ICOUNT=ICOUNT+1
              ENDIF
 111        CONTINUE
          ENDIF
            CALL ARLCCO(PPLUS, PMINUS, PX, PY, S)
            RX1 = PPLUS/(P(1,4)+P(1,3))
            RX2 = PMINUS/(P(2,4)-P(2,3))
            CALL ARPUTR(1)
            CALL ARUNDO(I1,I2,I3)
            CALL ARLCCO(PPLUS, PMINUS, PX, PY, S)
            RXP1 = PPLUS/(P(1,4)+P(1,3))
            RXP2 = PMINUS/(P(2,4)-P(2,3))
            CALL ARGETR(1)
            IF(QEX(I1).AND.(BP(I1,3).GT.0.AND.KFSAVE(1).NE.21.OR.
     $           BP(I1,3).LT.0.AND.KFSAVE(2).NE.21))THEN
              Z1 = RXP1/RX1
            ELSE
              Z1 = 1.0D0
            ENDIF
            IF(QEX(I3).AND.(BP(I3,3).GT.0.AND.KFSAVE(1).NE.21.OR.
     $           BP(I3,3).LT.0.AND.KFSAVE(2).NE.21))THEN
              Z2 = RXP2/RX2
            ELSE
              Z2 = 1.0D0
            ENDIF
c            call pypdfu(k(1,2),rx1,pt2,xpyst)
c            xfw = xpyst(kfsave(1))
c            call pypdfu(k(1,2),rxp1,pt2,xpyst)
c            xfw = xfw/xpyst(kfsave(1))
c            call pypdfu(k(1,2),rx2,pt2,xpyst)
c            xfw = xfw*xpyst(kfsave(2))
c            call pypdfu(k(1,2),rxp2,pt2,xpyst)
c            xfw = xfw/xpyst(kfsave(2))
C            write(*,*) xfw, 1.0D0/(Z1*Z2)*DBLE(ICOUNT)/DBLE(IMAX)

C....................
C            Z = BP(MAXPAR-2,5)**2/ARMAS2(I2,MAXPAR-2)
C            WRITE(*,*) Z,Z1*Z2
C            WRITE(*,*) 1.0D0/(Z1*Z2)*DBLE(ICOUNT)/DBLE(IMAX)
C            WRITE(*,*)
C....................
          IF ( QREC ) THEN
            ARPROB=1.0D0/(Z1*Z2)*DBLE(ICOUNT)/DBLE(IMAX)
C...Return to armeps
            RETURN
          ELSE
            PROB=PROB*Z1*Z2
          ENDIF
C...The naive estimate is good enought don't bother with
C...the complicated reconstruction
C...Copy particle data to temporary entries
c$$$          DO 101 I = 1,5
c$$$            BP(IPART+1, I) = BP(I1,I)
c$$$            BP(IPART+2, I) = BP(I2,I)
c$$$            BP(IPART+3, I) = BP(I3,I)
c$$$            BP(IPART+4, I) = BP(MAXPAR-2,I)
c$$$ 101      CONTINUE
c$$$
c$$$          I1I = IPART+1
c$$$          I2I = IPART+2
c$$$          I3I = IPART+3
c$$$
c$$$C...Boost all temporary particles to CM frame of particle 1 and 3
c$$$          CALL ARBCM2(I1I,I3I,THE,PHI1,DBEX,DBEY,DBEZ)
c$$$          CALL AROBO2(0.0D0,0.0D0,-DBEX,-DBEY,-DBEZ,I2I,IPART+4)
c$$$          CALL AROBO2(0.0D0,-PHI1,0.0D0,0.0D0,0.0D0,I2I,IPART+4)
c$$$          CALL AROBO2(-THE,0.0D0,0.0D0,0.0D0,0.0D0,I2I,IPART+4)
c$$$          
c$$$C...Calculated KT2 of emitted parton
c$$$          DKT = SQRT(BP(I2I,1)**2 + BP(I2I,2)**2)
c$$$          DKT2 = DKT**2
c$$$          
c$$$C...Transfer kt from the emitted parton to the Drell-Yan particle
c$$$          BP(IPART+4,1) = BP(IPART+4,1) + BP(I2I,1)
c$$$          BP(IPART+4,2) = BP(IPART+4,2) + BP(I2I,2)
c$$$          
c$$$C...Calculated the total light cone momenta before the emission.
c$$$          A = SQRT((BP(IPART+4,5)**2 + BP(IPART+4,1)**2 + 
c$$$     $         BP(IPART+4,2)**2)/(BP(IPART+4,4)**2-BP(IPART+4,3)**2))
c$$$          CPLUS = (1-A) * (BP(IPART+4,4)+BP(IPART+4,3)) +
c$$$     $         BP(I1I,4)+BP(I1I,3) + BP(I3I,4)+BP(I3I,3)
c$$$          CMINUS = (1-A) *(BP(IPART+4,4)-BP(IPART+4,3))
c$$$     $         + BP(I1I,4)-BP(I1I,3) + BP(I3I,4)-BP(I3I,3)
c$$$C...Check of things are kinematically possible to reconstruct
c$$$          IF(CMINUS .LE. 0 .OR. CPLUS .LE. 0 .OR. SQRT(CMINUS*CPLUS) 
c$$$     $         .LE.BP(I1I,5)+BP(I3I,5)+1.OR.(.NOT.(QEX(I1).AND.QEX(I3)) 
c$$$     $         .AND.(((BP(I2I,4)+BP(I2I,3)) .GT. A*(BP(MAXPAR-2,4)
c$$$     $         +BP(MAXPAR-2,3))) .OR. ((BP(I2I,4)-BP(I2I,3)).GT.
c$$$     $         A*(BP(MAXPAR-2,4)-BP(MAXPAR-2,3)))) ) )THEN
c$$$C...If things turn out impossible undo changes to the Drell-Yan particle
c$$$            BP(IPART+4,1) = BP(IPART+4,1) - BP(I2I,1)
c$$$            BP(IPART+4,2) = BP(IPART+4,2) - BP(I2I,2)
c$$$            QWRAP=.FALSE.
c$$$          ELSE
c$$$C...Boost the Drell-Yan particle so that its mass is maintained
c$$$            BP(IPART+4,3) = A*BP(IPART+4,3)
c$$$            BP(IPART+4,4) = A*BP(IPART+4,4)
c$$$C...Transfer the transverse momenta to the pariticles 1 and 3
c$$$            BP(I1I,1) = BP(I1I,1) - X3**2/(X1**2+X3**2)*BP(I2I,1)
c$$$            BP(I1I,2) = BP(I1I,2) - X3**2/(X1**2+X3**2)*BP(I2I,2)
c$$$            BP(I3I,1) = BP(I3I,1) - X1**2/(X1**2+X3**2)*BP(I2I,1)
c$$$            BP(I3I,2) = BP(I3I,2) - X1**2/(X1**2+X3**2)*BP(I2I,2)
c$$$C...Calculate the transverse mass
c$$$            DMT1 = SQRT(BP(I1I,5)**2 + BP(I1I,1)**2 + BP(I1I,2)**2)
c$$$            DMT3 = SQRT(BP(I3I,5)**2 + BP(I3I,1)**2 + BP(I3I,2)**2)
c$$$C...Set the energy to mt2 + pz2
c$$$            BP(I1I,4) = SQRT(DMT1**2+BP(I1I,3)**2)
c$$$            BP(I3I,4) = SQRT(DMT3**2+BP(I3I,3)**2)
c$$$            
c$$$C...Calculate boosts to CM of reconstructed system
c$$$            S = CPLUS*CMINUS
c$$$            BZ = (CPLUS-CMINUS)/(CPLUS+CMINUS)
c$$$            CALL AROBO2(0.0D0,0.0D0,0.0D0,0.0D0,-BZ,I1I,I3I)
c$$$            PPN = ARPCMS(S, DMT1, DMT3)
c$$$            PPO = BP(I1I,4) + BP(I1I,3)
c$$$            PPBZ = (PPN**2 - PPO**2)/(PPN**2 + PPO**2)
c$$$            
c$$$C...Calculate boosts to give pplus and pminus the correct values
c$$$            PMN = ARPCMS(S, DMT3, DMT1)
c$$$            PMO = BP(I3I,4) - BP(I3I,3)
c$$$            PMBZ = (PMO**2 - PMN**2)/(PMN**2 + PMO**2)
c$$$            CALL AROBO1(0.0D0,0.0D0,0.0D0,0.0D0,PPBZ,I1I)
c$$$            CALL AROBO1(0.0D0,0.0D0,0.0D0,0.0D0,PMBZ,I3I)
c$$$C...Boost to previous frame
c$$$            CALL AROBO2(0.0D0,0.0D0,0.0D0,0.0D0,BZ,I1I,I3I)
c$$$c     QWRAP = (BP(I2I,4)+BP(I2I,3)).LT.(BP(IPART+4,4)+BP(IPART+4,3)) 
c$$$c     $       .AND.(BP(I2I,4)-BP(I2I,3)).LT.(BP(IPART+4,4)-BP(IPART+4,3))
c$$$            QWRAP=.FALSE.
c$$$          ENDIF
c$$$C     NOT used anymore
c$$$C...Calculate z fraction
c$$$C          Z = BP(MAXPAR-2,5)**2/ARMAS2(I2I,IPART+4)
c$$$C...Calculate gluon rapidity
c$$$          Y = 0.5D0*LOG(ARMAS2(I1I,I2I)/ARMAS2(I2I,I3I))
c$$$          S123 = ARMAS3(I1I,I2I,I3I)
c$$$          
c$$$          A = 1.0D0
c$$$          B = 1.0D0
c$$$C...If arprob is called from arreco return a fraction
c$$$          IF(QEX(I1)) A = MIN((XPMU(I1)/SQRT(PT2))**XPA(I1),1)
c$$$          IF(QEX(I3)) B = MIN((XPMU(I3)/SQRT(PT2))**XPA(I3),1)
c$$$          IF(QEX(I1) .OR. QEX(I3))THEN
c$$$            XTMAX = A*B/(EXP(Y)*B+EXP(-Y)*A)
c$$$C***  no pdf in the choice of reconstruction
c$$$C     PROB = PROB * MIN((XTMAX**2/(PT2/S123))**PARA(25),1)
c$$$C***
c$$$            IF(QREC)THEN
c$$$              ARPROB = PROB * MIN((XTMAX**2/(PT2/S123))**PARA(25),1)
c$$$              RETURN
c$$$            ENDIF
c$$$C***
c$$$          ENDIF
        ELSE
C...If no Drell-Yan particle 
          Y = 0.5D0*LOG(ARMAS2(I2,I3)/ARMAS2(I1,I2))
          A = 1.0D0
          B = 1.0D0
          IF(QREC) THEN
            CALL ARFPA3(I2, I2, I2, IPAR, INP, SBP)
            DO 50 I = 1,5
              BP(IPART+1, I) = SBP(I)
 50         CONTINUE
            IF(INP.EQ.1) THEN
              Z = 1/( ARMAS2(IPART+1,I2)/DBLE(XQ2) + 1 )
            ELSE
              Z = SBP(5)**2/ARMAS2(IPART+1,I2)
            ENDIF
            IF(QEX(I1)) A = MIN((XPMU(I1)/SQRT(PT2))**XPA(I1)*
     $           (1.0D0/PYR(IDUM)-1.0D0)**DBLE(PARA(25)),1.0D0)
            IF(QEX(I3)) B = MIN((XPMU(I3)/SQRT(PT2))**XPA(I3)*
     $           (1.0D0/PYR(IDUM)-1.0D0)**DBLE(PARA(25)),1.0D0)
            XTMAX = A*B/(EXP(Y)*B+EXP(-Y)*A)
            IF(XTMAX**2.LT.PT2/S123)THEN
              ARPROB=0.0D0
            ELSE
              ARPROB=1.0D0/Z
            ENDIF
            RETURN
          ENDIF
          IF(QEX(I1)) A = MIN((XPMU(I1)/SQRT(PT2))**XPA(I1),1.0D0)
          IF(QEX(I3)) B = MIN((XPMU(I3)/SQRT(PT2))**XPA(I3),1.0D0)
          IF(QEX(I1) .OR. QEX(I3))THEN
            XTMAX = A*B/(EXP(Y)*B+EXP(-Y)*A)
C***  no pdf in the choice of reconstruction
C     PROB = PROB * MIN((XTMAX**2/(PT2/S123))**PARA(25),1)
          ENDIF
        ENDIF
      ELSE
        IF ( INQ(I1) .LT. 0 .AND. INQ(I1) .EQ. INQ(I3) ) THEN
C...Sea quark emission
C...Find the reqoil system
          CALL ARFPA3(I1, I2, I3, IPAR, INP, SBP)
C...Copy the sum of the fourvectors to a temporary praticle id
          DO 100 I = 1,5
            BP(IPART+1, I) = SBP(I)
 100      CONTINUE
C     PT2 = ARPT2S(I1, I2, I3)
C...Calculate z and x
          IF( MHAR(184).EQ.3 .AND. INP.EQ.1 ) THEN
C...DIS
            Z = 1/( ARMAS2(IPART+1,I2)/DBLE(XQ2) + 1)
            XQ = X
          ELSE
            DMASS2 = ARMAS2(IPART+1, I2)
            Z = SBP(5)**2/DMASS2
            XQ = SBP(5)**2/ARMAS4(I1,I2,I3,IPART+1)
          ENDIF
C...Check if pt2 och Q2 scale should be used
          IF(MHAR(127).LE.0)THEN
            XXQ2 = PT2/(1-Z)
          ELSE
            XXQ2 = MHAR(127) * PT2
          ENDIF
C...Check if XXQ2 is below the cutoff of the structure functions
          IF(XXQ2 .LE. 1.69D0) THEN
            XXQ2 = 1.69D0
          ENDIF
          IF(QREC)THEN
C...During reconstruction only include structure functions
            ARPROB = ARSTRA(K(K(-INQ(I1),3),2),-IFL(I2),XQ,Z,XXQ2)
            RETURN
          ENDIF
C...Calculate the probability for sea quark emission
C***  no pdf in the choice of reconstruction
C     PROB = PROB*ARSTRA(K(K(-INQ(I1),3),2), -IFL(I2), XQ, Z, 
C     $      XXQ2) 
          PROB = PROB * 0.25D0 * (1-Z) * ((1-Z)**2 + Z**2)/PT2
        ELSEIF( I3.EQ.MAXPAR-4 .OR. I3.EQ.MAXPAR-3)THEN
C...Calculate probability a quark emission from a proton remnant
C...This emission can not be generated by ARIADNE
C...Sum up recoil system and store in temporary particle id
          CALL ARFPA3(I1, I2, I3, IPAR, INP, SBP)
          DO 110 I = 1,5
            BP(IPART+1, I) = SBP(I)
 110      CONTINUE
          DMASS2 = ARMAS2(IPART+1, I2)
C...Calculate z and x
          Z = SBP(5)**2/DMASS2
C     PT2 = ARPT2S(I1, I2, I3)
C...  Check if pt2 och Q2 scale should be used
          IF(MHAR(127).LE.0)THEN
            XXQ2 = PT2/(1-Z)
          ELSE
            XXQ2 = MHAR(127) * PT2
          ENDIF
C...Check if XXQ2 is below the cutoff of the structure functions
          IF(XXQ2 .LE. 1.69D0) THEN
            XXQ2 = 1.69D0
          ENDIF
C...Determine x for the gluon
          IF(QQ(I3))THEN
            XG = SBP(5)**2/ARMAS4(I1,I2,I3,IPART+1)
          ELSE
            XG = SBP(5)**2/ARMAS3(I1,I2,IPART+1)
          ENDIF
C...Calculate ratio of structure functions
          CALL PYPDFU(K(K(-INQ(I1),3),2),XG/Z,XXQ2,XPYST)
          STRUCT = XPYST(IFL(I2))
          CALL PYPDFU(K(K(-INQ(I1),3),2),XG,XXQ2,XPYST)
          STRUCT = STRUCT/XPYST(0)
          IF(QREC)THEN
            ARPROB = STRUCT
            RETURN
          ENDIF
C***  no pdf in the choice of reconstruction
C     PROB = PROB*STRUCT
          PROB = PROB*2.0D0/3.0D0*(1-Z)*((1+(1-Z)**2)/Z)/PT2
        ELSE
C...Probatility for quark antiquark production
          PROB=PROB*0.125*((1.0D0-X3+SY3**2)**2+(1.0D0-X2+SY2**2)**2)/
     $         (1.0D0-X1+SY1**2)/S123
          IF ( MHAR(181).GT.0.OR.MSTA(23).GE.3 ) THEN
            IDN=IDO(I3)
            IF ( IDN.EQ.0 ) THEN
              I0=IP1(IDI(I3))
            ELSE
              I0=IP3(IDN)
            ENDIF
            PROB=PROB*2.0D0/(1.0D0+S123/ARMAS3(I0,I3,I2))
          ENDIF
        ENDIF
      ENDIF

      ARPROB=MAX(PROB,0.0D0)
      
      IF(QREC) ARPROB=1.0D0

      RETURN

C**** END OF ARPROB ****************************************************
      END
