C***********************************************************************
C $Id: arpt2s.f,v 3.3 2009/03/03 13:38:11 nils Exp $

      DOUBLE PRECISION FUNCTION ARPT2S(I1,I2,I3)

C...ARiadne function PT2 for Sea quark emission

C...Returns the invariant p_t^2 of two proton remains and 
C...a sum over the rest of the particles.

      INCLUDE 'arimpl.f'
      INCLUDE 'arpart.f'
      INCLUDE 'ardat1.f'

      DIMENSION IPAR(MAXPAR), SBP(5), P(5), B(3)

      CALL ARFPA3(I1, I2, I3, IPAR, INP, SBP)
      
      DO 100 I = 1,4
        P(I) = SBP(I)
        P(I) = P(I) + BP(I1, I)
        P(I) = P(I) + BP(I2, I)
        IF(I3.GE.MAXPAR-4.AND..NOT.QQ(I3))THEN
          BP(IPART+1,I) = BP(I1, I)
        ELSE
          P(I) = P(I) + BP(I3, I)
          BP(IPART+1,I) = BP(I1, I) + BP(I3, I)
        ENDIF
 100  CONTINUE
      BP(IPART+1, 5) = SQRT(BP(IPART+1, 4)**2 - BP(IPART+1, 1)**2  
     $  - BP(IPART+1, 2)**2 - BP(IPART+1, 3)**2)

      DO 110 I = 1,3
        B(I) = -P(I)/P(4)
 110  CONTINUE
      
      CALL AROBO1(0.0D0, 0.0D0, B(1), B(2), B(3), IPART+1)

      PHI = - ATAN2( BP(IPART+1, 2), BP(IPART+1, 1) )
      CALL AROBO1(0.0D0, PHI, 0.0D0, 0.0D0, 0.0D0, IPART+1)
      THE = - ATAN2(BP(IPART+1, 1), BP(IPART+1, 3))

      DO 120 I = 1,5
        BP(IPART+1, I) = BP(I2, I)
 120  CONTINUE

      CALL AROBO1(0.0D0, 0.0D0, B(1), B(2), B(3), IPART+1)
      CALL AROBO1(0.0D0, PHI, 0.0D0, 0.0D0, 0.0D0, IPART+1)
      CALL AROBO1(THE, 0.0D0, 0.0D0, 0.0D0, 0.0D0, IPART+1)
      ARPT2S = BP(IPART+1, 1)*BP(IPART+1, 1) +
     $  BP(IPART+1, 2)*BP(IPART+1, 2)
      
      RETURN
      
C**** END OF ARPT2S ****************************************************
      END


C***********************************************************************
C $Id: arpt2s.f,v 3.3 2009/03/03 13:38:11 nils Exp $

      DOUBLE PRECISION FUNCTION ARPT2G(I1,I2,I3)

C...ARiadne function to calculate pt2 for a gluon emmission from an
C...extended source

      INCLUDE 'arimpl.f'
      INCLUDE 'arpart.f'
C      save cplus,cminus,ppn,pmn

      I1I = I1
      I2I = I2
      I3I = I3
      IF((QEX(I1).AND.QEX(I3)).AND.IFL(I2).EQ.21.AND.QQ(MAXPAR-2))THEN
        CALL ARBCM2(I1,I3,THE,PHI1,DBEX,DBEY,DBEZ)
        CALL AROBO1(0.0D0,0.0D0,-DBEX,-DBEY,-DBEZ,I2)
        CALL AROBO1(0.0D0,-PHI1,0.0D0,0.0D0,0.0D0,I2)
        CALL AROBO1(-THE,0.0D0,0.0D0,0.0D0,0.0D0,I2)
        ARPT2G = BP(I2,1)**2+BP(I2,2)**2
        CALL AROBO3(THE,PHI1,DBEX,DBEY,DBEZ,I1,I2,I3)
        RETURN
      ENDIF

      ARPT2G = ARIPT2(I1I,I2I,I3I)

C**** END OF ARPT2G ****************************************************
      END

C***********************************************************************
C $Id: arpt2s.f,v 3.3 2009/03/03 13:38:11 nils Exp $

      DOUBLE PRECISION FUNCTION ARSHAT()

C...ARiadne function to calculate invariant mass**2 of all non 
C...extended particles.

      INCLUDE 'arimpl.f'
      INCLUDE 'arpart.f'

      DOUBLE PRECISION SP(4)

      DO 100 I = 1,4
        SP(I) = 0
 100  CONTINUE

      DO 110 I = 1,IPART
        DO 120 J = 1,4
          IF(.NOT.QEX(I)) SP(J) = SP(J) + BP(I,J)
 120    CONTINUE
 110  CONTINUE

      IF(QQ(MAXPAR-2))THEN
        DO 130 I = 1,4
          SP(I) = SP(I) + BP(MAXPAR-2, I)
 130    CONTINUE
      ENDIF

      ARSHAT = SP(4)**2 - SP(1)**2 - SP(2)**2 - SP(3)**2

C**** END OF ARSHAT ****************************************************
      END

C***********************************************************************
C $Id: arpt2s.f,v 3.3 2009/03/03 13:38:11 nils Exp $

      SUBROUTINE ARLCCO(PPLUS, PMINUS, PX, PY, S)

C...ARiadne function to calculate Light Cone COrdinats of all non 
C...extended particles.

      INCLUDE 'arimpl.f'
      INCLUDE 'arpart.f'

      DOUBLE PRECISION SP(4)

      DO 100 I = 1,4
        SP(I) = 0
 100  CONTINUE

      DO 110 I = 1,IPART
        DO 120 J = 1,4
          IF(.NOT.QEX(I)) SP(J) = SP(J) + BP(I,J)
 120    CONTINUE
 110  CONTINUE

      IF(QQ(MAXPAR-2))THEN
        DO 130 I = 1,4
          SP(I) = SP(I) + BP(MAXPAR-2, I)
 130    CONTINUE
      ENDIF

      PPLUS = SP(4) + SP(3)
      PMINUS = SP(4) - SP(3)
      PX = SP(1)
      PY = SP(2)
      S = PPLUS * PMINUS - PX**2 - PY**2

C**** END OF ARSHAT ****************************************************
      END
